(define-module (sx gui-gl))
(use-modules (gtk gdk) (gtk gtk)
             (open-gl gl)
             (open-gl glu)
             (open-gl gtkgl)
             (sx render))
(export *OPENGL_WINDOW* gui-update-gl-window gui-init-gl-window gui-gl-viewport-set)

; the Opengl window widget
(define *OPENGL_WINDOW* #f)

; OpenGL window related functions
; --------------------------------
(define (gui-update-gl-window compile)
  (with-gtk-gl-area:render! *OPENGL_WINDOW* 
    (render-scene 'render #f #f #f #f compile)
  )
)


(define (gui-gl-viewport-set w h)
  (set! *GL_VIEWPORT_WIDTH* w)
  (set! *GL_VIEWPORT_HEIGHT* h)
  (with-gtk-gl-area *OPENGL_WINDOW*
    (gl-viewport 0 0 *GL_VIEWPORT_WIDTH* *GL_VIEWPORT_HEIGHT*))
)


(define (gui-init-gl-window)
  (with-gtk-gl-area *OPENGL_WINDOW* (render-init))
)


